var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __knownSymbol = (name, symbol) => (symbol = Symbol[name]) ? symbol : Symbol.for("Symbol." + name);
var __typeError = (msg) => {
  throw TypeError(msg);
};
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __decoratorStart = (base) => {
  var _a;
  return [, , , __create((_a = base == null ? void 0 : base[__knownSymbol("metadata")]) != null ? _a : null)];
};
var __decoratorStrings = ["class", "method", "getter", "setter", "accessor", "field", "value", "get", "set"];
var __expectFn = (fn) => fn !== void 0 && typeof fn !== "function" ? __typeError("Function expected") : fn;
var __decoratorContext = (kind, name, done, metadata, fns) => ({ kind: __decoratorStrings[kind], name, metadata, addInitializer: (fn) => done._ ? __typeError("Already initialized") : fns.push(__expectFn(fn || null)) });
var __decoratorMetadata = (array, target) => __defNormalProp(target, __knownSymbol("metadata"), array[3]);
var __runInitializers = (array, flags, self, value) => {
  for (var i = 0, fns = array[flags >> 1], n = fns && fns.length; i < n; i++) flags & 1 ? fns[i].call(self) : value = fns[i].call(self, value);
  return value;
};
var __decorateElement = (array, flags, name, decorators, target, extra) => {
  var fn, it, done, ctx, access, k = flags & 7, s = !!(flags & 8), p = !!(flags & 16);
  var j = k > 3 ? array.length + 1 : k ? s ? 1 : 2 : 0, key = __decoratorStrings[k + 5];
  var initializers = k > 3 && (array[j - 1] = []), extraInitializers = array[j] || (array[j] = []);
  var desc = k && (!p && !s && (target = target.prototype), k < 5 && (k > 3 || !p) && __getOwnPropDesc(k < 4 ? target : { get [name]() {
    return __privateGet(this, extra);
  }, set [name](x) {
    return __privateSet(this, extra, x);
  } }, name));
  k ? p && k < 4 && __name(extra, (k > 2 ? "set " : k > 1 ? "get " : "") + name) : __name(target, name);
  for (var i = decorators.length - 1; i >= 0; i--) {
    ctx = __decoratorContext(k, name, done = {}, array[3], extraInitializers);
    if (k) {
      ctx.static = s, ctx.private = p, access = ctx.access = { has: p ? (x) => __privateIn(target, x) : (x) => name in x };
      if (k ^ 3) access.get = p ? (x) => (k ^ 1 ? __privateGet : __privateMethod)(x, target, k ^ 4 ? extra : desc.get) : (x) => x[name];
      if (k > 2) access.set = p ? (x, y) => __privateSet(x, target, y, k ^ 4 ? extra : desc.set) : (x, y) => x[name] = y;
    }
    it = (0, decorators[i])(k ? k < 4 ? p ? extra : desc[key] : k > 4 ? void 0 : { get: desc.get, set: desc.set } : target, ctx), done._ = 1;
    if (k ^ 4 || it === void 0) __expectFn(it) && (k > 4 ? initializers.unshift(it) : k ? p ? extra = it : desc[key] = it : target = it);
    else if (typeof it !== "object" || it === null) __typeError("Object expected");
    else __expectFn(fn = it.get) && (desc.get = fn), __expectFn(fn = it.set) && (desc.set = fn), __expectFn(fn = it.init) && initializers.unshift(fn);
  }
  return k || __decoratorMetadata(array, target), desc && __defProp(target, name, desc), p ? k ^ 4 ? extra : desc : target;
};
var __accessCheck = (obj, member, msg) => member.has(obj) || __typeError("Cannot " + msg);
var __privateIn = (member, obj) => Object(obj) !== obj ? __typeError('Cannot use the "in" operator on this value') : member.has(obj);
var __privateGet = (obj, member, getter) => (__accessCheck(obj, member, "read from private field"), getter ? getter.call(obj) : member.get(obj));
var __privateSet = (obj, member, value, setter) => (__accessCheck(obj, member, "write to private field"), setter ? setter.call(obj, value) : member.set(obj, value), value);
var __privateMethod = (obj, member, method) => (__accessCheck(obj, member, "access private method"), method);

// src/is-password.decorator.ts
import { registerDecorator } from "class-validator";

// src/password.constraint.ts
import {
  ValidatorConstraint
} from "class-validator";
var _PasswordConstraint_decorators, _init;
_PasswordConstraint_decorators = [ValidatorConstraint({ async: true })];
var PasswordConstraint = class {
  constructor() {
    this.errorMessage = "Password is invalid";
    this.defaultSpecialChars = [
      "!",
      "@",
      "#",
      "$",
      "%",
      "^",
      "&",
      "*",
      "(",
      ")"
    ];
    this.defaultBlacklistValues = ["12345678", "password"];
    this.defaultMessages = {
      blacklist: "Password is blacklisted",
      hasLowerCase: "Password must have at least one lowercase letter",
      hasNumbers: "Password must have at least one number",
      hasSpecialChars: "Password must have at least one special character",
      hasUpperCase: "Password must have at least one uppercase letter",
      minLength: "Password is too short",
      maxLength: "Password is too long",
      confirmPassword: "Passwords do not match"
    };
    this.defaultOptions = {
      blacklist: {
        enabled: true,
        values: this.defaultBlacklistValues,
        message: this.defaultMessages.blacklist
      },
      hasLowerCase: {
        enabled: true,
        message: this.defaultMessages.hasLowerCase
      },
      hasNumbers: {
        enabled: true,
        message: this.defaultMessages.hasNumbers
      },
      hasSpecialChars: {
        enabled: true,
        message: this.defaultMessages.hasSpecialChars,
        characters: this.defaultSpecialChars
      },
      hasUpperCase: {
        enabled: true,
        message: this.defaultMessages.hasUpperCase
      },
      minLength: {
        enabled: true,
        length: 8,
        message: this.defaultMessages.minLength
      },
      maxLength: {
        enabled: true,
        length: 15,
        message: this.defaultMessages.maxLength
      },
      confirmPassword: {
        enabled: false,
        message: this.defaultMessages.confirmPassword
      }
    };
  }
  // Validate the password based on provided options or defaults
  validate(value, args) {
    var _a, _b, _c;
    const options = this.mergeWithDefaults(
      (_a = args.constraints[0]) != null ? _a : {}
    );
    const obj = args.object;
    const confirmPassword = ((_b = options.confirmPassword) == null ? void 0 : _b.enabled) ? obj[(_c = options.confirmPassword.compareToProperty) != null ? _c : "confirmPassword"] : void 0;
    return this.validatePassword(value, confirmPassword, options);
  }
  // Return the default error message
  defaultMessage() {
    return this.errorMessage;
  }
  /**
   * Merge user-provided options with the default options.
   * Ensures that default messages are used when no custom message is provided.
   *
   * @param userOptions The options provided by the user.
   * @returns Merged options with default values for undefined properties.
   */
  mergeWithDefaults(userOptions) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _A, _B, _C, _D, _E, _F, _G, _H, _I, _J, _K, _L, _M, _N;
    return {
      blacklist: {
        enabled: (_b = (_a = userOptions == null ? void 0 : userOptions.blacklist) == null ? void 0 : _a.enabled) != null ? _b : this.defaultOptions.blacklist.enabled,
        values: (_d = (_c = userOptions == null ? void 0 : userOptions.blacklist) == null ? void 0 : _c.values) != null ? _d : this.defaultOptions.blacklist.values,
        message: (_f = (_e = userOptions == null ? void 0 : userOptions.blacklist) == null ? void 0 : _e.message) != null ? _f : this.defaultMessages.blacklist
      },
      hasLowerCase: {
        enabled: (_h = (_g = userOptions == null ? void 0 : userOptions.hasLowerCase) == null ? void 0 : _g.enabled) != null ? _h : this.defaultOptions.hasLowerCase.enabled,
        message: (_j = (_i = userOptions == null ? void 0 : userOptions.hasLowerCase) == null ? void 0 : _i.message) != null ? _j : this.defaultMessages.hasLowerCase
      },
      hasNumbers: {
        enabled: (_l = (_k = userOptions == null ? void 0 : userOptions.hasNumbers) == null ? void 0 : _k.enabled) != null ? _l : this.defaultOptions.hasNumbers.enabled,
        message: (_n = (_m = userOptions == null ? void 0 : userOptions.hasNumbers) == null ? void 0 : _m.message) != null ? _n : this.defaultMessages.hasNumbers
      },
      hasSpecialChars: {
        enabled: (_p = (_o = userOptions == null ? void 0 : userOptions.hasSpecialChars) == null ? void 0 : _o.enabled) != null ? _p : this.defaultOptions.hasSpecialChars.enabled,
        characters: (_r = (_q = userOptions == null ? void 0 : userOptions.hasSpecialChars) == null ? void 0 : _q.characters) != null ? _r : this.defaultOptions.hasSpecialChars.characters,
        message: (_t = (_s = userOptions == null ? void 0 : userOptions.hasSpecialChars) == null ? void 0 : _s.message) != null ? _t : this.defaultMessages.hasSpecialChars
      },
      hasUpperCase: {
        enabled: (_v = (_u = userOptions == null ? void 0 : userOptions.hasUpperCase) == null ? void 0 : _u.enabled) != null ? _v : this.defaultOptions.hasUpperCase.enabled,
        message: (_x = (_w = userOptions == null ? void 0 : userOptions.hasUpperCase) == null ? void 0 : _w.message) != null ? _x : this.defaultMessages.hasUpperCase
      },
      minLength: {
        enabled: (_z = (_y = userOptions == null ? void 0 : userOptions.minLength) == null ? void 0 : _y.enabled) != null ? _z : this.defaultOptions.minLength.enabled,
        length: (_B = (_A = userOptions == null ? void 0 : userOptions.minLength) == null ? void 0 : _A.length) != null ? _B : this.defaultOptions.minLength.length,
        message: (_D = (_C = userOptions == null ? void 0 : userOptions.minLength) == null ? void 0 : _C.message) != null ? _D : this.defaultMessages.minLength
      },
      maxLength: {
        enabled: (_F = (_E = userOptions == null ? void 0 : userOptions.maxLength) == null ? void 0 : _E.enabled) != null ? _F : this.defaultOptions.maxLength.enabled,
        length: (_H = (_G = userOptions == null ? void 0 : userOptions.maxLength) == null ? void 0 : _G.length) != null ? _H : this.defaultOptions.maxLength.length,
        message: (_J = (_I = userOptions == null ? void 0 : userOptions.maxLength) == null ? void 0 : _I.message) != null ? _J : this.defaultMessages.maxLength
      },
      confirmPassword: {
        enabled: (_L = (_K = userOptions == null ? void 0 : userOptions.confirmPassword) == null ? void 0 : _K.enabled) != null ? _L : this.defaultOptions.confirmPassword.enabled,
        message: (_N = (_M = userOptions == null ? void 0 : userOptions.confirmPassword) == null ? void 0 : _M.message) != null ? _N : this.defaultMessages.confirmPassword
      }
    };
  }
  /**
   * Perform all password validations.
   *
   * @param password The password to validate.
   * @param confirmPassword The password confirmation value (if applicable).
   * @param options The validation options to apply.
   * @returns True if the password passes all validations; otherwise, false.
   */
  validatePassword(password, confirmPassword, options) {
    const checks = [
      this.checkBlacklist(password, options),
      this.checkLength(password, options),
      this.checkRegex(password, options.hasUpperCase, /[A-Z]/g),
      this.checkRegex(password, options.hasLowerCase, /[a-z]/g),
      this.checkRegex(password, options.hasNumbers, /\d/g),
      this.checkSpecialChars(password, options),
      this.checkConfirmPassword(password, confirmPassword, options)
    ];
    return checks.every((result) => result);
  }
  // Validation functions remain unchanged but include comments for clarity
  /**
   * Validate if the password is not in the blacklist.
   */
  checkBlacklist(password, options) {
    var _a, _b;
    if ((_a = options.blacklist) == null ? void 0 : _a.enabled) {
      const blacklist = (_b = options.blacklist.values) != null ? _b : this.defaultBlacklistValues;
      if (blacklist.includes(password)) {
        this.errorMessage = options.blacklist.message;
        return false;
      }
    }
    return true;
  }
  /**
   * Validate the password length (min and max).
   */
  checkLength(password, options) {
    var _a, _b;
    if (((_a = options.minLength) == null ? void 0 : _a.enabled) && password.length < options.minLength.length) {
      this.errorMessage = options.minLength.message;
      return false;
    }
    if (((_b = options.maxLength) == null ? void 0 : _b.enabled) && password.length > options.maxLength.length) {
      this.errorMessage = options.maxLength.message;
      return false;
    }
    return true;
  }
  /**
   * Validate if the password matches a specific regex.
   */
  checkRegex(password, rule, regex) {
    if ((rule == null ? void 0 : rule.enabled) && !regex.test(password)) {
      this.errorMessage = rule.message;
      return false;
    }
    return true;
  }
  /**
   * Validate if the password contains special characters.
   */
  checkSpecialChars(password, options) {
    var _a, _b;
    if ((_a = options.hasSpecialChars) == null ? void 0 : _a.enabled) {
      const chars = (_b = options.hasSpecialChars.characters) != null ? _b : this.defaultSpecialChars;
      const regex = new RegExp(`[${chars.join("")}]`, "g");
      if (!regex.test(password)) {
        this.errorMessage = options.hasSpecialChars.message;
        return false;
      }
    }
    return true;
  }
  /**
   * Validate if the confirmation password matches the password.
   */
  checkConfirmPassword(password, confirmPassword, options) {
    var _a;
    if (((_a = options.confirmPassword) == null ? void 0 : _a.enabled) && confirmPassword !== password) {
      this.errorMessage = options.confirmPassword.message;
      return false;
    }
    return true;
  }
};
_init = __decoratorStart(null);
PasswordConstraint = __decorateElement(_init, 0, "PasswordConstraint", _PasswordConstraint_decorators, PasswordConstraint);
__runInitializers(_init, 1, PasswordConstraint);

// src/is-password.decorator.ts
function IsPassword(ValidatorOptions, defaultValidatorOptions) {
  return function(object, propertyName) {
    registerDecorator({
      target: object.constructor,
      propertyName,
      options: defaultValidatorOptions,
      constraints: [ValidatorOptions],
      validator: PasswordConstraint
    });
  };
}
export {
  IsPassword,
  PasswordConstraint
};
//# sourceMappingURL=index.mjs.map